<template>
  <div  style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="21" :spanTitle="2" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"></ReturnButton>
      <el-row :gutter="20">
      <!-- BUSCADOR --> 
       <el-col :span="6" :offset="18">
         <el-select @change="changeYears(yearSelected)" v-model="yearSelected" filterable placeholder="Buscar Año">
           <el-option
            v-for="materialType in objYears"
            :key="materialType._id"
            :label="materialType._id"
            :value="materialType._id">
           </el-option>
         </el-select>    
        </el-col>
      </el-row>
    </header>

    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
       <div class="margenes-comp-title" style="background-color: #494949">
        <h3 class="bolt-light"> 
          HISTORIAL
          <span style="margin-left: 0.5rem"> {{ yearSelected? yearSelected:new Date().getFullYear() }} </span>
          <span style="margin-left: 2rem"> {{ typeSupport }} </span>
        </h3> 
      </div>
    </div>

    <section v-if="pedidosPendientes.length !== 0" style="margin:0rem 6rem 4rem">
      <div style="padding: 10px 20px" class=" title-views text-red">PEDIDOS PENDIENTES </div>         
      <el-table :header-cell-class-name="tableRowClassName"
        :data="pedidosPendientes"
        style="width: 100%;margin-top:2rem;"
        :stripe=true :border=true>
      <el-table-column
        prop="dateOfOrder"
        label="Fecha de Pedido"
        width="180"
         >
      </el-table-column>
      <el-table-column
        prop="orderSupport"
        label="Tipo de Soporte"
        width="180">
    </el-table-column>
      <el-table-column
        prop="quantity"
        label="N° de Discos">
      </el-table-column>
      <el-table-column
        prop="unitaryImport"
        label="Importe Unitario">
      </el-table-column>
      <el-table-column
        prop="total"
        label="Importe Total">
      </el-table-column>
      <el-table-column
        prop="stateOrder"
        label="Estado" >
      </el-table-column>
    </el-table>
      <hr style="margin-top: 4rem">      
    </section>

       <!-- COMPONENTE SUB TITULO -->
    <div style="margin:0rem 6rem">
      <app-title Title="PEDIDOS RECIBIDOS"  bgColor="background-color: #fe7234 !important" > </app-title>
    </div>
    
    <section style="margin:0rem 7rem 4rem" v-if="pedidosRecibidos">
      <el-row style="margin:0 0 1rem 3rem">
        <el-col :span="7">
          <span class="title-views">Total de Pedidos Realizados: <br></span>                        
        </el-col>
        <el-col :span="12">
            <span class="title-views text-orange"> {{ cantidadPedidosRecibos }} <br></span>
        </el-col>
      </el-row> 

      <el-row style="margin:0 0 1rem 3rem">
        <el-col :span="6">
          <span class="title-views">Importe Total Anual: <br></span>                        
        </el-col>
        <el-col :span="12">
          <span class="title-views text-orange">S/.<span> {{ montoTotalPedidosRecibidos }} </span></span>
        </el-col>
      </el-row> 
    </section>

    <section style="margin:0rem 10rem 7rem;display:block;overflow:hidden!important" v-for="item  in pedidosRecibidos" :key="item.mes" >
      
      <!-- TITULO DEL MES  -->
      <div style="background-color: #fedbcc !important; color: #252525 !important; padding: 8px 20px;overflow:hidden!important">
        <h3 class="text-bold" style="display:block"> {{ item.mes}} <span class="bolt-light" style="margin-left: 10px" >  {{ item.pedidos.length }} pedidos </span> </h3> 
      </div>
      
      <el-col  v-for="(pedido,i) in item.pedidos" :key="pedido._id">
        <el-row  style="margin:5rem 3rem 0">
          <el-col >
            <p  class="text-orange title-views"> Pedido {{ i + 1 }}:  </p>
          </el-col>
        </el-row>
        <!-- 1ERA FILA DEL MES -->
        <el-row :gutter="90" style="margin:1rem">
          <el-col :span="8">
            <div style="margin: 2rem 0" class="line-heigth">
              <p style="padding-left: 20px" class="bg-gray text-bold">Número de Pedido</p>
              <p style="padding:0.5rem  5px 5px 20px"> {{ pedido.numberOrder }}</p>
            </div>
          </el-col>
          <el-col :span="8">
            <div style="margin: 2rem 0" class="line-heigth">
              <p style="padding-left: 20px" class="bg-gray text-bold">Fecha de Pedido</p>
              <p style="padding: 0.5rem 5px 5px 20px"> {{ pedido.dateOfOrder }} </p>
            </div>
          </el-col>
          <el-col :span="8">
            <div style="margin: 2rem 0" class="line-heigth">
              <p style="padding-left: 20px" class="bg-gray text-bold"> Tipo de Soporte </p>
              <p style="padding: 0.5rem 5px 5px 20px"> {{ pedido.orderSupport }} </p>
            </div>
          </el-col>
        </el-row>
          <!-- 2ERA FILA DEL MES -->
        <el-row :gutter="90" style="margin:1rem">
          <el-col :span="8">
            <div  class="line-heigth">
              <p style="padding-left: 20px" class="bg-gray text-bold">N° de Discos</p>
              <p style="padding: 0.5rem 5px 5px 20px">{{ pedido.quantity }} </p>
            </div>
          </el-col>
          <el-col :span="8">
            <div  class="line-heigth">
              <p style="padding-left: 20px;" class="bg-gray text-bold">Importe Unitario</p>
              <p style="padding: 0.5rem 5px 5px 20px"> {{ pedido.unitaryImport }}</p>
            </div>
          </el-col>
          <el-col :span="8">
            <div class="line-heigth">
              <p style="padding-left: 20px" class="bg-gray text-bold"> Importe Total </p>
              <p class="text-orange text-bold" style="padding: 0.5rem 5px 5px 20px"> <span> S/. </span> {{ pedido.total }} </p>
            </div>
          </el-col>
        </el-row>
        <!-- RECEPCION DE DISCOS -->
        <el-row :gutter="60" style="margin:1rem" > 
          <el-col> 
            <div style="margin: 2rem 0">
              <p style="padding: 5px 5px 5px 20px" class="bg-gray text-bold text-orange">Recepcion de Discos </p>         
              <el-row>
                <el-col :span="8" v-for="(recibido, index) in pedido.recived" :key="index">
                  <el-row style="margin: 1rem 0">
                    <el-col :span="7">
                      <span style="padding-left: 20px" class="fonts-bold-general">Fecha: <br></span>                        
                    </el-col>
                    <el-col :span="7">
                      <span class="fonts-bold-general" > {{ utilFormatDate(recibido.dateArrived) }} <br></span>
                    </el-col>
                  </el-row>  
                  <el-row>
                    <el-col :span="12">
                      <span style="padding-left: 20px" class="fonts-bold-general">Discos Recibidos: <br></span>                        
                    </el-col>
                    <el-col :span="7">
                      <span class="fonts-bold-general"> {{ recibido.receivedDiscs}} <br></span>
                    </el-col>
                  </el-row>
                </el-col>  
              </el-row>  
            </div> 
          </el-col>  
        </el-row>
      </el-col>

    </section>
  </div>  
</template>
<script>

import ReturnButton from '@/components/ReturnButton.vue'
import { HTTP } from '../../../main.js'
import Title from '@/components/Title.vue' 
import Select from '@/components/AppSelect.vue'
import { convertDate } from '../../../utils/calculateTime.js'
 

export default {
  components: {
    'app-title': Title,
    'app-select': Select,
      ReturnButton
  },
  data() {
    return {
      supports:[],
      typeSupport: JSON.parse(localStorage.getItem("typeSupport")), 
      yearSelected: '',
      enumMeses:['ENERO','FEBRERO','MARZO','ABRIL','MAYO','JUNIO','JULIO','AGOSTO','SETIEMBRE','OCTUBRE','NOVIEMBRE','DICIEMBRE'],
      yearDefault: new Date().getFullYear(),
      objYears: [],

    }
  },
  created () {
    this.getYears()
    this.getSupportsRegister(new Date().getFullYear())
  },
  methods: {
    utilFormatDate(stringDate){
      return new Date(stringDate).toLocaleString("en-GB",{day:'numeric',month:'numeric',year:'numeric'})
    },
    getSupportsRegister (year) {      
      HTTP.get('supports/year?year=' + year + '&typeSupport=' + this.typeSupport)
      .then(res => {
        this.supports = res.data
        this.supports.map(el=>{
          el.total = el.quantity * el.unitaryImport;
          el.dateOfOrder = this.utilFormatDate(el.dateOfOrder);
        })       
      })
      .catch(console.log); 
    },
    getYears () {
      HTTP.get('supports/years')
      .then( res => this.objYears = res.data )
      .catch(console.log);   
    },
    changeYears (item) {
      this.getSupportsRegister(item)
      this.yearDefault = item
    },
    calculateInfoByYears () {
      this.supportPending = []
      this.supportComplete = []
      this.soporteFiltradoPorAño = []
      this.pedidosPorMeses = [
        {mes: "ENERO", ordersPlaced: []},
        {mes: "FEBRERO", ordersPlaced:  []},
        {mes: "MARZO", ordersPlaced:  [] },
        {mes: "ABRIL", ordersPlaced:  [] },
        {mes: "MAYO", ordersPlaced:  [] },
        {mes: "JUNIO", ordersPlaced:  [] },
        {mes: "JULIO", ordersPlaced:  [] },
        {mes: "AGOSTO", ordersPlaced:  [] },
        {mes: "SEPTIEMBRE", ordersPlaced: []},
        {mes: "OCTUBRE", ordersPlaced:  []},
        {mes: "NOVIEMBRE", ordersPlaced: [] },
        {mes: "DICIEMBRE", ordersPlaced: []}
        ]

      this.tipoDeSoporteElegido.map(( el, i, arr ) => {              
        if( el.stateOrder == 'PENDIENTE') {
          this.supportPending.push(el)
        }
        else {
          this.supportComplete.push(el)
          this.pedidosPorMeses[el.month -1].ordersPlaced.push(el)                
        }
      })
      this.getInfoStorage()
    },

    getInfoStorage (){ // jalando data de storageMat

      let matStroge = [] // todos los materiales enlatados
      this.materials.map((material)=>{
        if((material.canned===true) && (material.storageMat.length > 0)){
          matStroge.push(material)
        }
      })

      matStroge.map((mat)=>{
        let storage = mat.storageMat[mat.storageMat.length-1]
        if(mat.providerName !== ''){ // SOLO ENLATADOS
          if(storage.infoByChapter){ //materiales con capitulos         
            storage.infoByChapter.map((chapter)=>{
              
              let achapter = chapter[chapter.length-1]// seleccionado capitulo actualizado
              let date = convertDate(achapter.dateOfCopy)
              achapter.supportMaterial.map((code)=>{
                // objeto con la informacion solicitada de almacen de soporte
                let info = {
                              correlativeNumber:code.codeDisk,
                              materialType:mat.typeOfContent,
                              materialTitle:mat.listTitle,
                              theChapter:achapter.chapter,
                              dateOfCopy:date
                            }
                
                this.arrayAllObjects.push(info)
              })
            })
          }
          else{// materiales sin capitulos(largometrajes y otros)
            
            let date = convertDate(storage.dateOfCopy) // convertir timestamp a dd/mm/yy
            storage.supportMaterial.map((code)=>{
              
              let info = {
                correlativeNumber:code.codeDisk,
                materialType:mat.typeOfContent,
                materialTitle:mat.listTitle,
                dateOfCopy:date
              }
            
            this.arrayAllObjects.push(info)
            })
          }
        }
        else{ // TELEVISA
          // console.log(storage)
          if(storage.infoByChapter){ //materiales con capitulos         
            storage.infoByChapter.map((chapter)=>{
              
              let date = convertDate(chapter.dateCopy)
              chapter.typeStorage.map((code)=>{
            //     // objeto con la informacion solicitada de almacen de soporte
                let info = {
                              correlativeNumber: code.codeDisk,
                              materialType: mat.typeOfContent,
                              materialTitle: mat.listTitle,
                              theChapter: chapter.chapter,
                              dateOfCopy: date
                            }
                
                this.arrayAllObjects.push(info)
              })
            })
          }
          else{// materiales sin capitulos(especiales)
            
            let date = convertDate(storage.dateCopy) // convertir timestamp a dd/mm/yy
            storage.typeStorage.map((code)=>{
              
              let info = {
                correlativeNumber: code.codeDisk,
                materialType: mat.typeOfContent,
                materialTitle: mat.listTitle,
                dateOfCopy: date
              }
            
            this.arrayAllObjects.push(info)
            })
          }
        }
      }) 
      this.arrayTodos = [] // array con informacion de los materiales  en soporte almacen
      this.supportComplete.map((item, index)=>{ // pedidos recibidos en colleccion soporte
      
        let arrayOrders = []// array de materiales de un mismo pedido
        item.codByOrder.map((infoCode)=>{

          this.arrayAllObjects.map((obj)=>{
            if(infoCode.correlativeNumber === obj.correlativeNumber){ //materiales con codigo disco
              arrayOrders.push(obj)
            }
          })
        })
              
        this.arrayTodos.unshift(arrayOrders)
      })
    },
    returnPage () {
      this.$router.push({ name: 'supportHistory'})
    },

    tableRowClassName ({row, rowIndex}) {
      if (rowIndex === 0) {
        return 'bg-pink-stick'
      }
    }
  },
  computed: {
    pedidosPendientes(){return this.supports.filter(el=>el.stateOrder==='PENDIENTE')},
    cantidadPedidosRecibos() { return this.supports.filter(el=>el.stateOrder!=='PENDIENTE').length },
    montoTotalPedidosRecibidos() { 
      let count = 0
      this.supports.forEach(el=>{
        if(el.stateOrder!=='PENDIENTE') count += el.quantity * el.unitaryImport;
      })
      return count
    },
    pedidosRecibidos(){
      let pedidos = this.supports.filter(el=>el.stateOrder!=='PENDIENTE');
      let meses = [...new Set(pedidos.map(el=>el.month))]
      let arrPedidos = []
      meses.forEach(el=>{
        let obj = {};
        obj.mes = this.enumMeses[parseInt(el) - 1];
        obj.pedidos = pedidos.filter(element=>element.month == el);
        arrPedidos.push(obj)
      })
      return arrPedidos;
  }
  }
}

</script>


